
--https://github.com/tomrus88/BlizzardInterfaceCode
local CChatFilter=LibStub("AceAddon-3.0"):NewAddon(BFF_ADDON_NAME, "AceConsole-3.0","AceTimer-3.0")
local cfgreg = LibStub("AceConfigRegistry-3.0")

local function update_player_info()
    local _, class, _ = UnitClass('player')
    bfwf_player.class=class
    bfwf_player.classes=1   --单一职业
    if class=='SHAMAN' or class=='PRIEST' or class=='WARRIOR' then
        bfwf_player.classes = 2 --双职业
    elseif class == 'DRUID' or class=='PALADIN' then
        bfwf_player.classes = 3  --三职业
    end
end

--插件加载完成
function CChatFilter:OnInitialize()
    self:RegisterChatCommand("bff", "OnCommand")

    bfwf_configs_init()

    bfwf_minimap_button_init()
    bfwf_chat_filter_init()
end

----------------------------------------------------------------------------------------
--  Auto Join
----------------------------------------------------------------------------------------
local function Join()
    JoinPermanentChannel("大脚世界频道")
    ChatFrame_AddChannel(DEFAULT_CHAT_FRAME, "大脚世界频道")    -- body
end

function JoinBigfoot()
    C_Timer.NewTicker(1, Join, 30)
end

function Big()
	C_Timer.After(10, JoinBigfoot)
end

function LeaveBigfoot()
    LeaveChannelByName("大脚世界频道");
    ChatFrame_RemoveChannel(DEFAULT_CHAT_FRAME, "大脚世界频道")
end

local BF = CreateFrame("FRAME") 
BF:RegisterEvent("PLAYER_ENTERING_WORLD") 
BF:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_ENTERING_WORLD" then
		if BFWC_Filter_SavedConfigs.bigfoot == true then
			Big()
		end
	end
end)




--用户登录完成
function CChatFilter:OnEnable()
    if not self.timer then
        self.timer = self:ScheduleRepeatingTimer("OnCheck", 1)
    end

    if BFWC_Filter_SavedConfigs.use_class_color then
        SetCVar("chatClassColorOverride", "0")
    end

    if not bfwf_g_data.myid then
        bfwf_g_data.myid,_ = UnitGUID('player')
    end

    bfwf_player.level = UnitLevel('player')

    if not BFWC_Filter_SavedConfigs.player then
        BFWC_Filter_SavedConfigs.player = {}
    end
    if bfwf_g_data.myid and not BFWC_Filter_SavedConfigs.player[bfwf_g_data.myid] then
        BFWC_Filter_SavedConfigs.player[bfwf_g_data.myid] = {}
    end

    update_player_info()

    self:OnLevelUp()

    if BFWC_Filter_SavedConfigs.show_drag_handle then
        bfwf_show_drag_handle()
    end
end

function CChatFilter:OnDisable()
    if self.timer then
        self:CancelTimer(self.timer)
        self.timer = nil
    end
end

function CChatFilter:OnCommand(input)
    bfwf_toggle_config_dialog()
end

local last_level = 0
function CChatFilter:OnCheck()
    if not bfwf_player.class then
        update_player_info()
    end

    if not bfwf_g_data.myid then
        bfwf_g_data.myid,_ = UnitGUID('player')
    end

    bfwf_player.level = UnitLevel('player') or bfwf_player.level

    if bfwf_player.level>last_level then
        self:OnLevelUp()
    end

    if not bfwf_g_data.myid then
        bfwf_g_data.myid = UnitGUID('player')
    end

    bfwf_update_config_dialog()

    if bfwf_update_ui and cfgreg then
        bfwf_update_ui = false
        cfgreg:NotifyChange(BFF_ADDON_NAME)
    end
end

function BFFGetJoinedChannels()
    local chns={}
    for i=1,10 do
        local frm=_G['ChatFrame'..i]
        if frm and frm.GetID then
            local id = frm:GetID()
            if id then
                local arr={GetChatWindowChannels(id)}
                for j,v in ipairs(arr) do
                    if type(v)=='string' then
                        table.insert(chns,v)
                    end
                end
            end
        end
    end
    return chns
end

local function BFFGetChannelID(chname)
    if not chname then
        return nil
    end
    local arr={GetChannelList()}
    for i,k in ipairs(arr) do
        if k == chname then
            return arr[i-1]
        end
    end
    return nil
end

bfwf_update_dungeons_filter = function()
    if BFWC_Filter_SavedConfigs.auto_filter_by_level then
        local lv = bfwf_player.level
        for _,d in ipairs(bfwf_dungeons) do
            if lv>=d.lmin and lv<= d.lmax then
                BFWC_Filter_SavedConfigs.dungeons[d.name] = true
            else
                BFWC_Filter_SavedConfigs.dungeons[d.name] = false
            end
        end
    end
end
function CChatFilter:OnLevelUp()
    last_level = bfwf_player.level
    bfwf_update_dungeons_filter()
end